%% compute how many extremal ellipse-vertices there are
%#ok<*FXSET>
%#ok<*SAGROW>
 
%[pt,norm1,iter1,time1,norm2,iter2,time2] = deal( {} );
%%
return;
%%
 
[pt,nrm] = deal( {} );
[dim,time] = deal( [] );
n_tmp = 10;
%% generate data
%clear
%load dump_extremal_cube_point
runflag = true;
while( runflag == true )
    for saveloop = 1:10;
        dim_tmp = randi(9)+1;
        n_tmp = randi(300) + dim_tmp;
        for repeat = 1:1 %make every combination three times

            % generate ellipses whose complex and real part is uniformly distributed in the unit ball
            % Harman and Lacko, 2010
            pt_tmp = rand( dim_tmp, n_tmp );

            % sort from large norm to small norm, so we remove a lot of vertices at the beginning (we start from removing at the end)
            [~,idx] = sort( sum(abs(pt_tmp.^2),1), 2, 'descend' );
            pt_tmp = pt_tmp(:,idx);    
            % compute norms
            n2 = nan( 3, size(pt_tmp,2) );
            STEP = min( n_tmp, 50 ); %roughly eight times the number of workers
            start_tmp = tic;
            fprintf( 'dim = %i, n = %i\n', dim_tmp(end), n_tmp(end) );
            for j = size( pt_tmp, 2 ):-STEP:1;
                startidx = max( 1, j-STEP+1 );
                endidx = j;
                Vidx = ~(n2(2,:)<1-5e-5);
                parfor k = startidx:endidx;
                    idx = Vidx;
                    idx(k) = false;
                    [ n2(:,k) ] = polytopenorm( pt_tmp(:,k), pt_tmp(:,idx), 'r', 'bound',[0 1], 'g', 'numthread',1 );
                end
                fprintf('\b\b');
            end;

            % store results
            pt{end+1} = pt_tmp;
            dim(end+1) = dim_tmp;
            time(end+1) = toc( start_tmp );
            nrm{end+1} = n2;
            fprintf( '\n\n' );
        end
        % save results
        save dump_extremal_cube_point
    end;
end

%% load results and make plot variables
% LABEL CLEARANDLOAD
clear
%%
% LABEL LOAD
load dump_extremal_cube_point
clear pt_tmp_i pt_tmp_r pt_tmp n2 ans dim_tmp j k iter  STEP startidx endidx repeat runflag n_tmp  start_tmp idx Vidx

EPS_PT = 1e-9;
DIM_PT = dim;
NUMEL_NRM_PT = cellfun( @(x) size(x,2), nrm );
NUMEL_PT_PT = cellfun( @(x) size(x,2), pt );
assert( isequal(NUMEL_NRM_PT,NUMEL_PT_PT) );
NUMEL_PT = NUMEL_PT_PT;
IN_PT = cellfun( @(x) nnz(x(2,:)<1-EPS_PT), nrm );
OUT_PT = cellfun( @(x) nnz(x(1,:)>1+EPS_PT), nrm );
BD_PT = NUMEL_PT_PT - IN_PT - OUT_PT;

