%% compute how many extremal ellipse-vertices there are
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%#ok<*FXSET>
%#ok<*SAGROW>

return;

%% initialize variables
 
[pt,nrm] = deal( {} );
[dim,time] = deal( [] );
load dump_extremal_gaussian_point

%% generate data
while( true )
    dim_tmp = randi(9) + 1;
    n_tmp = randi(30) + 1;
    for repeat = 1:3 %make every combination three times
        pt_tmp = randn( dim_tmp, n_tmp );
        % sort from large norm to small norm, so we remove a lot of vertices at the beginning (we start from removing at the end)
        [~,idx] = sort( sum(abs(pt_tmp.^2),1), 2, 'descend' );
        pt_tmp = pt_tmp(:,idx);    
        % compute norms
        n2 = nan( 3, size(pt_tmp,2) );
        STEP = min( n_tmp, 50 ); %roughly eight times the number of workers
        start_tmp = tic;
        fprintf( 'dim = %i, n = %i\n', dim_tmp(end), n_tmp(end) );
        for j = size( pt_tmp, 2 ):-STEP:1;
            startidx = max( 1, j-STEP+1 );
            endidx = j;
            Vidx = ~(n2(2,:)<1-5e-5);
            parfor k = startidx:endidx;
                [ n2(:,k) ] = polytopenorm( pt_tmp(:,k), pt_tmp(:,Vidx), 'r', 'bound',[0 1], 'g' );
            end
            fprintf('\b\b');
        end;

        % save results
        pt{end+1} = pt_tmp;
        dim(end+1) = dim_tmp;
        time(end+1) = toc( start_tmp );
        nrm{end+1} = n2;
        %save dump_extremal_gaussian_point
        fprintf( '\n\n' );
    end;
end

%% load results and make plot variables
% LABEL CLEARANDLOAD
clear
%%
% LABEL LOAD
load dump_extremal_gaussian_point
clear ans dim_tmp startidx endidx j k n2 n_tmp pt_tmp sortpt start_tmp STEP Vidx

EPS_PT = 1e-9;
DIM_PT = dim;
NUMEL_NRM_PT = cellfun( @(x) size(x,2), nrm );
NUMEL_PT_PT = cellfun( @(x) size(x,2), pt );
assert( isequal(NUMEL_NRM_PT,NUMEL_PT_PT) );
NUMEL_PT = NUMEL_PT_PT;
IN_PT = cellfun( @(x) nnz(x(2,:)<1-EPS_PT), nrm );
OUT_PT = cellfun( @(x) nnz(x(3,:)>1+EPS_PT), nrm );
BD_PT = NUMEL_PT_PT - IN_PT - OUT_PT;










