%% compute how many extremal ellipse-vertices there are
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%#ok<*FXSET>
%#ok<*SAGROW>

return;

%% initialize variables
 
[pt,nrm] = deal( {} );
[dim,time] = deal( [] );
load dump_extremal_gaussian

%% generate data
load dump_extremal_gaussian
while( true )
    dim_tmp = randi(15) + 1;
    n_tmp = n_tmp + randi( 5 );
    for repeat = 1:1 %make every combination three times
        pt_tmp = randn( dim_tmp, n_tmp ) + 1i*randn( dim_tmp, n_tmp );    
        % sort from large norm to small norm, so we remove a lot of vertices at the beginning (we start from removing at the end)
        [~,idx] = sort( sum(abs(pt_tmp.^2),1), 2, 'descend' );
        pt_tmp = pt_tmp(:,idx);    
        % compute norms
        n2 = nan( 3, size(pt_tmp,2) );
        STEP = min( n_tmp, 50 ); %roughly eight times the number of workers
        start_tmp = tic;
        fprintf( 'dim = %i, n = %i\n', dim_tmp(end), n_tmp(end) );
        for j = size( pt_tmp, 2 ):-STEP:1;
            startidx = max( 1, j-STEP+1 );
            endidx = j;
            Vidx = ~(n2(2,:)<1-5e-5);
            parfor k = startidx:endidx;
                [ n2(:,k) ] = polytopenorm( pt_tmp(:,k), pt_tmp(:,Vidx), 'ce', 'bound',[0 1], 'g' );
            end
            fprintf('\b\b');
        end;

        % save results
        pt{end+1} = pt_tmp;
        dim(end+1) = dim_tmp;
        time(end+1) = toc( start_tmp );
        nrm{end+1} = n2;
        save dump_extremal_gaussian
        fprintf( '\n\n' );
    end;
end

%% load results and make plot variables
% LABEL CLEARANDLOAD
clear
%%
% LABEL LOAD
load dump_extremal_gaussian
clear ans dim_tmp startidx endidx j k n2 n_tmp pt_tmp sortpt start_tmp STEP Vidx

deleteidx = [34 52 98 240 276 314]; %fix data, since something went wrong while storing
dim(deleteidx) = [];
pt(deleteidx) = [];

EPS_EL = 1e-9;
DIM_EL = dim;
NUMEL_NRM_EL = cellfun( @(x) size(x,2), nrm );
NUMEL_PT_EL = cellfun( @(x) size(x,2), pt );
assert( isequal(NUMEL_NRM_EL,NUMEL_PT_EL) );
NUMEL_EL = NUMEL_PT_EL;
IN_EL = cellfun( @(x) nnz(x(2,:)<1-EPS_EL), nrm );
OUT_EL = cellfun( @(x) nnz(x(1,:)>1+EPS_EL), nrm );
BD_EL = NUMEL_PT_EL - IN_EL - OUT_EL;










