%% main script
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% we want to compare the results of mixed-method3 (COMPLEXFUNCT) and method1 (COMPLEXFUNCT_B) 
% on vertices and polytopes occuring in case (C) in the invariant polytope algorithm
%

%#ok<*UNRCH>
%#ok<*SAGROW>

return;

%% generate vertices and polytopes and dump them to base-ws
clear
[T,nfo_b,nfo,dim,fail] = deal( {} );
%%
load ipa_dump
runflag = true;
dim_tmp = 7;
while( runflag );    
    if( rand<1/20 );
        dim_tmp = dim_tmp + randi(2); end;
    if( rand<1/20 );
        dim_tmp = dim_tmp - randi(2); end;
    if( dim_tmp<=6 );
        dim_tmp = max([dim{:}]) - 1; end;
    
    T_tmp = tgallery( 'complex', dim_tmp, 2 );
    if( isempty(T_tmp) );
        continue; end;

    try;
        [ ~, nfo_b_tmp ] = tjsr( T_tmp, 'maxiteration',300, 'admissiblealgorithm',[20 21 22 23 24 25 26], 'algorithm','cb', 'epssym',nan, 'solver','g' );
        [ ~, nfo_tmp ] = tjsr( T_tmp, 'maxiteration',300, 'admissiblealgorithm',[20 21 22 23 24 25 26], 'algorithm','c', 'epssym',nan, 'solver','g' );
        failflag = false;
    catch;
        failflag = true; end;
    
    check = @(x,a) numel(x.blockvar)==1 && isfield( x.blockvar{1}, 'cyclictree' ) && isfield( x.blockvar{1}.cyclictree, 'algorithm' ) && x.blockvar{1}.cyclictree.algorithm==a;
    cb = check( nfo_b_tmp, 22 );
    c = check( nfo_tmp, 20 );
    if( xor(cb,c) || failflag );
        fail{end+1} = T_tmp; 
        continue; end;
    if( ~cb );
        continue; end;
    
    T{end+1} = T_tmp;
    nfo_b{end+1} = nfo_b_tmp;
    nfo{end+1} = nfo_tmp;
    dim{end+1} = dim_tmp;

    clear check T_tmp var_b_tmp var_e_tmp c cb nfo_b_tmp nfo_tmp
    save ipa_dump;
    fprintf( '\n==================================\n' );
end

%%
% LABEL CLEARANDLOAD
clear
%% load variables and make plot variables
% LABEL LOAD
load ipa_dump
clear ans dim_tmp runflag nfo_b_tmp nfo_tmp VIO TIME TIME_B SUCCESS_B SUCCESS NV NV_B JSR JSR_B DIM DIM_B idx idx_

DIM = cellfun( @(x) x.param.dim, nfo );
DIM_B = cellfun( @(x) x.param.dim, nfo_b );
TIME = cellfun( @(x) x.log.treetime, nfo );
TIME_B = cellfun( @(x) x.log.treetime, nfo_b );
NV = cellfun( @(x) [x.blockvar{1}.cyclictree.norm{:}], nfo, 'uni', false );
NV = cellfun( @(x) nnz(x(2,:)>1-5e-9), NV );
NV_B = cellfun( @(x) [x.blockvar{1}.cyclictree.norm{:}], nfo, 'uni', false );
NV_B = cellfun( @(x) nnz(x(2,:)>1-5e-9), NV_B );
JSR = cellfun( @(x) x.JSR, nfo, 'uni',false );
JSR_B = cellfun( @(x) x.JSR, nfo_b, 'uni',false );
SUCCESS = cellfun( @(x) numel(x)==1, JSR );
SUCCESS_B = cellfun( @(x) numel(x)==1, JSR_B );

assert( isequal( DIM, DIM_B ) );
assert( isequal( size(TIME), size(TIME_B) ) );

%% plot

import exportfig.*
FIG();
clf; hold on;

MS = 3;
MS_b = 5;
LINESPEC = 'o';
LINESPEC_B = '.';
VIO = 0.1;

plotm( [DIM(SUCCESS);TIME(SUCCESS)],         'color',log10(NV(SUCCESS)),     'semilogy', 'violin',[0 VIO],  LINESPEC,   'ms',MS );
plotm( [DIM_B(SUCCESS_B);TIME_B(SUCCESS_B)], 'color',log10(NV_B(SUCCESS_B)), 'semilogy', 'violin',[-VIO 0], LINESPEC_B, 'ms',MS_b );

plotm( [DIM(~SUCCESS);TIME(~SUCCESS)],         'semilogy', 'violin',[0 VIO], 'x',    'color','r', 'ms',MS );
plotm( [DIM_B(~SUCCESS_B);TIME_B(~SUCCESS_B)], 'semilogy', 'violin',[-VIO 0], 'x', 'color','r', 'ms',MS_b );

colormap hsv
cbh = colorbar;
cbh.Ticks = [1 2 3 4] ; %Create 8 ticks from zero to 1
cbh.TickLabels = {10 100 1000 10000} ; 
caxis([0 4])
SZE(4,2); AXIS([0 20 1 10^4]); TICKS([0 5 10 15 20 25 30 40],[1e1 1e2 1e3 1e4]); 
LABEL('$d$','$t\ [sec]$'); TITLE(''); POST();
SAVE('.','ipa',EXT);

%plotm( [TIME;TIME_B], 'color', DIM )
















