function main

 %#ok<*AGROW>
 %#ok<*DEFNU>
 %%
 [ex,nfo,fail] = deal( {} );
 %%
    for dim = 18:80
       sqm = ttest.sqmatrix( 'sze', dim );
        for n = 1:300/dim
            while( true );
                assignin( 'base', 'rr', rng )
                %rng( evalin('base','rr') );
                ex_tmp = full( sqm.example() );
                if( ipacase(ex_tmp)=='c' && rho(ex_tmp)>1e-6 );
                    break; end; end;
            disp( ex_tmp );
            [JSR,nfo_tmp] = tjsr( {ex_tmp}, 'invariantsubspace','none', 'minnummatrix',1, 'v',1, 'algorithm','cb', 'solver','g', 'maxiteration',500 );
            
            if ( numel(JSR)~=1 );
                fail{end+1} = ex_tmp;
            end; 
            ex{end+1} = ex_tmp;
            nfo{end+1} = nfo_tmp;
            clear ex_tmp nfo_tmp n rr ans
            save lyapunov_dump
        end
    end
%%
end

function script
%% load results and make plot variables
clear 
load lyapunov_dump.mat %#ok<LOAD>
clear val Szx Sxz sqm Rzb Rxa rr Pyz Pxy N n JSR ex_tmp al be
DIM = cellfun( @(x) x.param.dim, nfo );
TIME = cellfun( @(x) x.log.treetime, nfo );
NV = cellfun( @(x) [x.blockvar{1}.cyclictree.norm{:}], nfo, 'uni', false );
NV = cellfun( @(x) nnz(x(2,:)>1-5e-9), NV );

%% plot
import exportfig.*
FIG(); 
clf;
plotm( [DIM;TIME], '.', 'ms',5, 'semilogy', 'color',log10(NV), 'violin',[-.1 .1] )
colormap hsv
cbh = colorbar;
cbh.Ticks = [1 2 3 4] ; %Create 8 ticks from zero to 1
cbh.TickLabels = {10 100 1000 10000} ; 
caxis([.8 3.5])
SZE(4,2); AXIS([0 40 1 10^4]); TICKS([0 10 20 30 40],[1e1 1e2 1e3 1e4]); 
LABEL('$d$','$t\ [sec]$'); TITLE(''); POST();
SAVE('.','lyapunov');


end

function ret = ipacase( A );
    A = full( A );
    if( isreal(A) && all( A(:)>=0 ) );
        ret = 'p';
    else;
        d = eig( A );
        if( ~isvector(d) );
            d = diag(d); end;
        [maxval] = max( abs(d) );
        idx = abs(abs(d)-maxval)<1e-12;
        idx = find(idx);
        if( numel(idx)>3 );
            ret = 'm';
        elseif( numel(idx)==2 )
            if( norm(d(idx(1))-conj(d(idx(2))))<1e-10 && ~isreal(d(idx(1))) );
                ret = 'c';
            else;
                ret = 'm'; end;
        elseif( isreal(d(idx)) );
            ret = 'r';
        else;
            ret = 'c'; end; end;
end