%% main script
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% we want to compare the results of method3 (COMPLEXFUNCT_D) and method1 (COMPLEXFUNCT_B) 
% on vertices and polytopes occuring in case (C) in the invariant polytope algorithm
%

%#ok<*UNRCH>
%#ok<*SAGROW>

return;
%% generate vertices and polytopes and dump them to base-ws
clear
dim = 2;
j = 0;
lastidx = 0;
%%
load methodcomparison_cd_ipa;
% runflag = true;
% while( runflag );    
%     j = j + 1;
%     fprintf( 'j = %i\n', j );
%     if( rand<1/20 );
%         dim = dim + randi(3); end;
%     T_ = tgallery( 'complex', dim, 2 );
%     clear pt_VV_
%     tjsr( T_, 'maxiteration',45, 'admissiblealgorithm',[20 21 22 23 24 25 26], 'algorithm','cb', 'epssym',nan, 'solver','g', 'dumpvertex','pt_VV_' );
    for k = 1:numel(pt_VV);
        k
        [ dm1(k).normval, ~,  dm1(k).iter,  dm1(k).time ]  = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^1  ); fprintf('\n');
        [ dm3(k).normval, ~,  dm3(k).iter,  dm3(k).time ]  = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^3  ); fprintf('\n');
        [ dm5(k).normval, ~,  dm5(k).iter,  dm5(k).time ]  = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^5  ); fprintf('\n');
        [ dm7(k).normval, ~,  dm7(k).iter,  dm7(k).time ]  = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^7  ); fprintf('\n');
        [ dm9(k).normval, ~,  dm9(k).iter,  dm9(k).time ]  = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^9  ); fprintf('\n');
        [ dm11(k).normval, ~, dm11(k).iter, dm11(k).time ] = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^11 ); fprintf('\n');
        fprintf( '\n' );
    end
    
%     lastidx = numel(pt_VV);
%     save methodcomparison_cd_ipa;
%     fprintf( '\n==================================\n' );
% end

%% recompute missing stuff
for k = 1:numel( pt_VV );
    k
	[ dm1(k).normval, ~,  dm1(k).iter,  dm1(k).time ]  = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^1  ); fprintf('\n');
    [ dm3(k).normval, ~,  dm3(k).iter,  dm3(k).time ]  = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^3  ); fprintf('\n');
    [ dm5(k).normval, ~,  dm5(k).iter,  dm5(k).time ]  = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^5  ); fprintf('\n');
    [ dm7(k).normval, ~,  dm7(k).iter,  dm7(k).time ]  = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^7  ); fprintf('\n');
    [ dm9(k).normval, ~,  dm9(k).iter,  dm9(k).time ]  = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^9  ); fprintf('\n');
    [ dm11(k).normval, ~, dm11(k).iter, dm11(k).time ] = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^11 ); fprintf('\n');
    %save methodcomparison_cd_ipa;
end

%% load data
%%%%%%%%%%%%%%%
% LABEL CLEARANDLOAD
clear
%%
% LABEL LOAD
load methodcomparison_cd_ipa;
clear ans dim j runflag T_ lastidx k

IDX_ipa = ~arrayfun( @(n) isempty(pt_VV(n).pts), 1:numel(pt_VV) );
dm1_ipa = dm1(IDX_ipa);
dm3_ipa = dm3(IDX_ipa);
dm5_ipa = dm5(IDX_ipa);
dm7_ipa = dm7(IDX_ipa);
dm9_ipa = dm9(IDX_ipa);
dm11_ipa = dm11(IDX_ipa);
pt_VV_ipa = pt_VV(IDX_ipa);

len_ipa = arrayfun( @(i) size(pt_VV_ipa(i).pts,2), 1:numel(pt_VV_ipa) );
L1_ipa = @(X) arrayfun( @(i) repmat(X(i),[1 len_ipa(i)]), 1:numel(len_ipa), 'UniformOutput',false );
L2_ipa = @(X) [X{:}];
L_ipa = @(X) L2_ipa(L1_ipa(X));

NVV_ipa = arrayfun( @(n) size(pt_VV(n).VV,2), 1:numel(pt_VV) );
NVV_L_ipa = L_ipa( NVV_ipa );

DIM_ipa = arrayfun( @(n) size(pt_VV(n).VV,1), 1:numel(pt_VV) );
DIM_L_ipa = L_ipa( DIM_ipa );

ACC1_L_ipa  = [dm1_ipa.normval];  ACC1_L_ipa =  ACC1_L_ipa(3,:)./ACC1_L_ipa(2,:);
ACC3_L_ipa  = [dm3_ipa.normval];  ACC3_L_ipa =  ACC3_L_ipa(3,:)./ACC3_L_ipa(2,:);
ACC5_L_ipa  = [dm5_ipa.normval];  ACC5_L_ipa =  ACC5_L_ipa(3,:)./ACC5_L_ipa(2,:);
ACC7_L_ipa  = [dm7_ipa.normval];  ACC7_L_ipa =  ACC7_L_ipa(3,:)./ACC7_L_ipa(2,:);
ACC9_L_ipa  = [dm9_ipa.normval];  ACC9_L_ipa =  ACC9_L_ipa(3,:)./ACC9_L_ipa(2,:);
ACC11_L_ipa = [dm11_ipa.normval]; ACC11_L_ipa = ACC11_L_ipa(3,:)./ACC11_L_ipa(2,:);

TIME1_L_ipa  = [dm1_ipa.time];
TIME3_L_ipa  = [dm3_ipa.time];
TIME5_L_ipa  = [dm5_ipa.time];
TIME7_L_ipa  = [dm7_ipa.time];
TIME9_L_ipa  = [dm9_ipa.time];
TIME11_L_ipa = [dm11_ipa.time];
