%% main script
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% we want to compare the results of method3 (COMPLEXFUNCT_D) and method1 (COMPLEXFUNCT_B) 
% on vertices and polytopes occuring in case (C) in the invariant polytope algorithm
%

%#ok<*UNRCH>
%#ok<*SAGROW>

return;
%% generate vertices and polytopes and dump them to base-ws
clear
dim = 2;
lastidx = 0;
pt_VV = struct;
%%
load methodcomparison_cd_rnd
runflag = true;
while( runflag );    
    if( rand<1/20 );
        dim = dim + 3; end;
    pt_VV(end+1).pts = randncp( dim, 100 );
    pt_VV(end).VV = randncp( dim, randp( [1 1], 4*dim, 3000, 2 ) );
    for k = lastidx+1:numel(pt_VV);
        [ dm1(k).normval, ~,  dm1(k).iter,  dm1(k).time ]  = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^1  ); fprintf('\n');
        [ dm3(k).normval, ~,  dm3(k).iter,  dm3(k).time ]  = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^3  ); fprintf('\n');
        [ dm5(k).normval, ~,  dm5(k).iter,  dm5(k).time ]  = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^5  ); fprintf('\n');
        [ dm7(k).normval, ~,  dm7(k).iter,  dm7(k).time ]  = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^7  ); fprintf('\n');
        [ dm9(k).normval, ~,  dm9(k).iter,  dm9(k).time ]  = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^9  ); fprintf('\n');
        [ dm11(k).normval, ~, dm11(k).iter, dm11(k).time ] = polytopenorm( pt_VV(k).pts, pt_VV(k).VV, 'cd', 'm', 'rel',1-0.5^11 ); fprintf('\n');
        fprintf( '\n' );
    end
    
    lastidx = numel( pt_VV );
    %save methodcomparison_cd_rnd;
    fprintf( '\n==================================\n' );
end;


%% load data
%%%%%%%%%%%%%%%
% LABEL CLEARANDLOAD
clear
%%
% LABEL LOAD
load methodcomparison_cd_rnd;
clear ans dim j runflag T_ lastidx k

IDX_r = ~arrayfun( @(n) isempty(pt_VV(n).pts), 1:numel(pt_VV) );
dm1_r = dm1(IDX_r);
dm3_r = dm3(IDX_r);
dm5_r = dm5(IDX_r);
dm7_r = dm7(IDX_r);
dm9_r = dm9(IDX_r);
dm11_r = dm11(IDX_r);
pt_VV_r = pt_VV(IDX_r);

len_r = arrayfun( @(i) size(pt_VV_r(i).pts,2), 1:numel(pt_VV_r) );
L1_r = @(X) arrayfun( @(i) repmat(X(i),[1 len_r(i)]), 1:numel(len_r), 'UniformOutput',false );
L2_r = @(X) [X{:}];
L_r = @(X) L2_r(L1_r(X));

NVV_r = arrayfun( @(n) size(pt_VV_r(n).VV,2), 1:numel(pt_VV_r) );
NVV_L_r = L_r( NVV_r );

DIM_r = arrayfun( @(n) size(pt_VV_r(n).VV,1), 1:numel(pt_VV_r) );
DIM_L_r = L_r( DIM_r );

ACC1_L_r  = [dm1.normval];  ACC1_L_r =  ACC1_L_r(3,:)./ACC1_L_r(2,:);
ACC3_L_r  = [dm3.normval];  ACC3_L_r =  ACC3_L_r(3,:)./ACC3_L_r(2,:);
ACC5_L_r  = [dm5.normval];  ACC5_L_r =  ACC5_L_r(3,:)./ACC5_L_r(2,:);
ACC7_L_r  = [dm7.normval];  ACC7_L_r =  ACC7_L_r(3,:)./ACC7_L_r(2,:);
ACC9_L_r  = [dm9.normval];  ACC9_L_r =  ACC9_L_r(3,:)./ACC9_L_r(2,:);
ACC11_L_r = [dm11.normval]; ACC11_L_r = ACC11_L_r(3,:)./ACC11_L_r(2,:);

ACC1_r = cellfun( @mean, arrayfun( @(i) [dm1_r(i).normval(3,:)./dm1_r(i).normval(2,:)], 1:numel(dm1_r), 'uni', false ) );
ACC3_r = cellfun( @mean, arrayfun( @(i) [dm3_r(i).normval(3,:)./dm3_r(i).normval(2,:)], 1:numel(dm3_r), 'uni', false ) );
ACC5_r = cellfun( @mean, arrayfun( @(i) [dm5_r(i).normval(3,:)./dm5_r(i).normval(2,:)], 1:numel(dm5_r), 'uni', false ) );
ACC7_r = cellfun( @mean, arrayfun( @(i) [dm7_r(i).normval(3,:)./dm7_r(i).normval(2,:)], 1:numel(dm7_r), 'uni', false ) );
ACC9_r = cellfun( @mean, arrayfun( @(i) [dm9_r(i).normval(3,:)./dm9_r(i).normval(2,:)], 1:numel(dm9_r), 'uni', false ) );
ACC11_r = cellfun( @mean, arrayfun( @(i) [dm11_r(i).normval(3,:)./dm11_r(i).normval(2,:)], 1:numel(dm11_r), 'uni', false ) );

TIME1_r  = [dm1_r.time]./len_r;
TIME3_r  = [dm3_r.time]./len_r;
TIME5_r  = [dm5_r.time]./len_r;
TIME7_r  = [dm7_r.time]./len_r;
TIME9_r  = [dm9_r.time]./len_r;
TIME11_r = [dm11_r.time]./len_r;

TIME1_L_r  = L_r( TIME1_r );
TIME3_L_r  = L_r( TIME3_r );
TIME5_L_r  = L_r( TIME5_r );
TIME7_L_r  = L_r( TIME7_r );
TIME9_L_r  = L_r( TIME9_r );
TIME11_L_r = L_r( TIME11_r );
